﻿using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Threading.Tasks;

using Integrations.Api.Sdk;

using Newtonsoft.Json;

namespace ConsoleApp
{
    class Program
    {
        private const string BaseUrl = "https://www.znanylekarz.pl";
        private const string TokenUrl = "/oauth/v2/token";
        private const string ClientId = "your_id";
        private const string ClientSecret = "your_secret";

        static async Task Main(string[] args)
        {
            Console.WriteLine("Hello World let's integrate!");

            var httpClient = new HttpClient()
            {
                BaseAddress = new Uri(BaseUrl)
            };
            httpClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Bearer", await GetToken());
            var apiTest = new FacilitiesClient(httpClient);
            var result = await apiTest.FacilitiesGetAsync();

            Console.WriteLine(JsonConvert.SerializeObject(result));
        }

        private static async Task<string> GetToken()
        {
            var client = new HttpClient
            {
                BaseAddress = new Uri(BaseUrl)
            };
            var authenticationString = $"{ClientId}:{ClientSecret}";
            var base64EncodedAuthenticationString =
                Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(authenticationString));
            var values = new List<KeyValuePair<string, string>>
            {
                new KeyValuePair<string, string>("grant_type", "client_credentials"),
                new KeyValuePair<string, string>("scope", "integration")
            };
            var content = new FormUrlEncodedContent(values);
            var requestMessage = new HttpRequestMessage(HttpMethod.Post, TokenUrl)
            {
                Content = content
            };
            requestMessage.Headers.Add("Authorization", $"Basic {base64EncodedAuthenticationString}");
            var responseMessage = await client.SendAsync(requestMessage);
            var token = JsonConvert.DeserializeObject<TokenResponse>(await responseMessage.Content.ReadAsStringAsync());
            return token.Token;
        }
    }
}
